libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader > Class Template Reference documentation

Public Types | Public Member Functions | Private Types | Private Attributes | List of all members
libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader > Class Template Reference

`#include <IWAField.h>`

Inheritance diagram for libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >:

## Public Types
typedef ValueT | value_type
typedef ValueT & | reference_type
typedef const ValueT & | const_reference_type
typedef container_type::const_iterator | const_iterator
typedef container_type::const_reverse_iterator | const_reverse_iterator
Public Types inherited from libetonyek::IWAField
enum | Tag { TAG_INT32 , TAG_INT64 , TAG_UINT32 , TAG_UINT64 , TAG_SINT32 , TAG_SINT64 , TAG_BOOL , TAG_ENUM , TAG_FIXED64 , TAG_SFIXED64 , TAG_DOUBLE , TAG_STRING , TAG_BYTES , TAG_MESSAGE , TAG_FIXED32 , TAG_SFIXED32 , TAG_FLOAT }

## Public Member Functions
| IWAFieldImpl ()
IWAField::Tag | tag () const override
bool | is () const override
const_reference_type | get () const
bool | empty () const override
std::size_t | size () const override
const_reference_type | operator[] (const std::size_t index) const
const_iterator | begin () const
const_iterator | end () const
const_reverse_iterator | rbegin () const
const_reverse_iterator | rend () const
const std::deque< value_type > | repeated () const
const boost::optional< value_type > | optional () const
void | parse (const RVNGInputStreamPtr_t &input, const unsigned long length, const bool allowEmpty) override
Public Member Functions inherited from libetonyek::IWAField
virtual | ~IWAField ()=0
virtual Tag | tag () const =0
virtual bool | empty () const =0
virtual std::size_t | size () const =0
virtual bool | is () const =0
| operator bool () const
bool | operator! () const
virtual void | parse (const RVNGInputStreamPtr_t &input, unsigned long length, bool allowEmpty)=0

## Private Types
typedef boost::container::deque< ValueT > | container_type

## Private Attributes
container_type | m_values

## Member Typedef Documentation

## ◆ const_iterator

template<IWAField::Tag TagV, typename ValueT , typename Reader >

typedef container_type::const_iterator libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::const_iterator

## ◆ const_reference_type

template<IWAField::Tag TagV, typename ValueT , typename Reader >

typedef const ValueT& libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::const_reference_type

## ◆ const_reverse_iterator

template<IWAField::Tag TagV, typename ValueT , typename Reader >

typedef container_type::const_reverse_iterator libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::const_reverse_iterator

## ◆ container_type

template<IWAField::Tag TagV, typename ValueT , typename Reader >

typedef boost::container::deque<ValueT> libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::container_type
| private

## ◆ reference_type

template<IWAField::Tag TagV, typename ValueT , typename Reader >

typedef ValueT& libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::reference_type

## ◆ value_type

template<IWAField::Tag TagV, typename ValueT , typename Reader >

typedef ValueT libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::value_type

## Constructor & Destructor Documentation

## ◆ IWAFieldImpl()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::IWAFieldImpl | ( |  | ) |
| inline

## Member Function Documentation

## ◆ begin()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const_iterator libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::begin | ( |  | ) | const
| inline

## ◆ empty()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

bool libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::empty | ( |  | ) | const
| inlineoverridevirtual

Implements libetonyek::IWAField.

Referenced by libetonyek::IWAParser::parseDrawableShape(), and libetonyek::IWAParser::parseGroup().

## ◆ end()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const_iterator libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::end | ( |  | ) | const
| inline

## ◆ get()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const_reference_type libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::get | ( |  | ) | const
| inline

Referenced by libetonyek::get(), and libetonyek::get_optional_value_or().

## ◆ is()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

bool libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::is | ( |  | ) | const
| inlineoverridevirtual

Implements libetonyek::IWAField.

## ◆ operator[]()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const_reference_type libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::operator[] | ( | const std::size_t | index | ) | const
| inline

## ◆ optional()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const boost::optional< value_type > libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::optional | ( |  | ) | const
| inline

Referenced by libetonyek::IWAObjectIndex::parse(), libetonyek::IWAParser::parseCellStyle(), libetonyek::IWAParser::parseCharacterStyle(), libetonyek::IWAParser::parseDrawableShape(), libetonyek::IWAParser::parseGraphicStyle(), libetonyek::IWAParser::parseListStyle(), libetonyek::IWAParser::parseMediaStyle(), libetonyek::IWAParser::parseParagraphStyle(), libetonyek::IWAParser::parseSectionStyle(), libetonyek::IWAParser::parseShapePlacement(), libetonyek::NUM3Parser::parseShapePlacement(), libetonyek::KEY6Parser::parseSlideStyle(), libetonyek::IWAParser::parseTableStyle(), libetonyek::IWAParser::readPadding(), libetonyek::IWAParser::readPosition(), libetonyek::IWAParser::readRef(), and libetonyek::IWAParser::readSize().

## ◆ parse()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

void libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::parse | ( | const RVNGInputStreamPtr_t & | input,
|  | const unsigned long | length,
|  | const bool | allowEmpty
| ) |  |
| inlineoverridevirtual

Implements libetonyek::IWAField.

## ◆ rbegin()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const_reverse_iterator libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::rbegin | ( |  | ) | const
| inline

## ◆ rend()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const_reverse_iterator libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::rend | ( |  | ) | const
| inline

## ◆ repeated()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

const std::deque< value_type > libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::repeated | ( |  | ) | const
| inline

Referenced by libetonyek::IWAObjectIndex::parse(), libetonyek::IWAParser::parsePath(), libetonyek::IWAParser::readRefs(), libetonyek::IWAParser::readStroke(), libetonyek::IWAParser::readUIDs(), and libetonyek::IWAObjectIndex::scanColorFileMap().

## ◆ size()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

std::size_t libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::size | ( |  | ) | const
| inlineoverridevirtual

Implements libetonyek::IWAField.

Referenced by libetonyek::IWAParser::parseListStyle().

## ◆ tag()

template<IWAField::Tag TagV, typename ValueT , typename Reader >

IWAField::Tag libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::tag | ( |  | ) | const
| inlineoverridevirtual

Implements libetonyek::IWAField.

## Member Data Documentation

## ◆ m_values

template<IWAField::Tag TagV, typename ValueT , typename Reader >

container_type libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::m_values
| private

Referenced by libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::begin(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::empty(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::end(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::get(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::is(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::operator[](), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::optional(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::parse(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::rbegin(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::rend(), libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::repeated(), and libetonyek::detail::IWAFieldImpl< TagV, ValueT, Reader >::size().

The documentation for this class was generated from the following file:

- IWAField.h